import pygame, sys, time, random, numpy as np
from pygame.locals import *
pygame.init()

#set up background music of the game
pygame.mixer.music.load('wind.mp3')
pygame.mixer.music.play(-1, 0.0)
musicPlaying = True
WINDOWWIDTH = 1
WINDOWHEIGHT = 1
windowSurface = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT), 0, 32)
pygame.display.set_caption('Animation')


#take the player's name
print('What is your name, player?')
playerName = input()




#display the intro of the game and take the player's input as the player's name
def displayIntro():
    print()
    print()
    print('Once upon a time,' + playerName +', a ancient hero,')
    print('who is trapped in the dungeon by the dark force.')
    print('Two thousand years after his capture in the dungeon,')
    print('The outside world is facing great danger.')
    print('...')
    time.sleep(1)
    print('...')
    time.sleep(2)
    print('It is now the beginning of the journey of our hero,' + playerName)
    print('to save the world again, from the dark force.')
    time.sleep(3)
    print('...')
    time.sleep(2)
    print('Well, only if our hero,' + playerName +' could get out of the dungeon first,')
    print ('..........')
    time.sleep(3)
    print ('Old sayings that only the one who could complete three puzzles of numbers')
    time.sleep(1)
    print ('would be able to escape from the dungeon')
    print ('so ' + playerName + ',')
    time.sleep(2)
    print('are you ready?')
    

    
###########################################################################
#first mission of the game, the guessing game, which let the player
#to guess the randomly generated integer from 1 to 15 in 8 shots.(pretty easy one)
def Guess():
    print(' ')
    print(' ')
    print('Here we are, at a ancient stone wall, you have reached a dead end')
    time.sleep(2)
    print(playerName + ', only by completing this quest will buy you the pass')
    time.sleep(2)
    print('...')
    print('to the way out.')
    time.sleep(2)

    guessTaken = 0
    number = random.randint(1,20)
    print('')
    print('')
    print('Well, ' + playerName +', you have to figure out a mystery number between 1 and 20')
    while guessTaken < 8:
        print('Take a guess.')
        guess = input()
        guess = int(guess)

        guessTaken = guessTaken + 1

        if guess < number:
            print('Too low.')

        if guess > number:
            print('Too high.')

        if guess == number:
            break

    if guess == number:
        guessTaken = str(guessTaken)
        print('You got it right!! ' + playerName + 'You just get the pass')
        time.sleep(1)
        print('to the next level. Good Job!! You are close to the exit')

    if guess != number:
        number = str(number)
        print('Sorry, '+playerName + 'you failed this quest')
        print('Do you want to play again?')
        playAgain = input()
        if playAgain == 'yes' or playAgain == 'y':
            Guess()
        else:
            sys.exit()
#end of the guessing game
##########################################################################


##########################################################################
#second level of the dungeon which is a simple matrix multiplication game
#player have to input the right answer to move on
def Multi():
    A = np.matrix('3 6 1; 5 2 9; 4 5 7')
    B = np.matrix('5;7;8')
    print(' ')
    print()
    print('Now you have reached wall, the writing on it is so fuzzy')
    time.sleep(1)
    print('but, still, you can see it is like:')
    print(' ')
    time.sleep(1)
    print('oh, it is:')
    print(A);
    time.sleep(1)
    print('oh, there is more!')
    time.sleep(1)
    print(B)
    time.sleep(1)
    print('obviously, it is puzzle, waiting for you to solve')
    print('hint: sum of the elements in A*B')
    print('you only have one shot')

    ans = input()
    if ans == '287':
        print('You Got it right!! Now move up to the final level!!')
    else:
        print('Sorry, '+playerName + 'you failed this quest')
        print('Do you want to play again?')
        playAgain2 = input()
        if playAgain2 == 'yes' or playAgain2 == 'y':
            Multi()
        else:
            sys.exit()
#end of the multiplication
##########################################################################


##########################################################################
    
#the final stage of the dungeon game,which is based on the luck of the player
#choosing between two cave. Randomly one is the cave to win the game
#and another kills the player. The player could choose to replay the game or quit.

#intro of the dragon game
def dragon():
    print()
    print()
    print('Now you have come to the dragon realms. Dragons are the wardens of the dungeon')
    time.sleep(1)
    print('In front of you are two caves')
    time.sleep(1)
    print('one of them would point you the way out of the dungeon')
    time.sleep(2)
    print('the other will eat you on sight.')
    time.sleep(1)
    print('so, be careful, ' + playerName, 'it is your choice...')
    print()
#let the player choose a cave between 1 and two
def chooseCave():
    cave = ''
    while cave != '1' and cave != '2':
        print('Which cave will you go into? (1 or 2)')
        cave = input()

    return cave

#determine whether the cave chosen is good or bad
def checkCave (chosenCave):
    print('You approach the cave...')
    time.sleep(2)
    print('It is dark and spooky...')
    time.sleep(2)
    print('A large dragon suddenly appears in front of you! He opens his jaw and...')
    print()
    time.sleep(2)

    GoodCave = random.randint(1,2)

    if chosenCave == str(GoodCave):
        print('points you the way out of dungeon.')
        time.sleep(2)
        print('Congratulations! ' + playerName +', time for you to save the world out there!')
    else:
        print('gobbles you down in one bite!!' )

#end of the dragon game
##################################################################
#warm up for the game, it is a previous homework question
def warmup():
    print()
    print()
    print('first of all, a little bit warm up')
    time.sleep(1)
    print('What is the least composite number that has all')
    print('of the first 5 prime numbers as factors?')
    answer = input()
    if answer == '2310':
        print('right, now you are ready to go !!')
    else:
        print('well, the answer should be 2310. Concentration!!! ' + playerName)





playAgain = 'yes'
while playAgain == 'yes' or playAgain == 'y':
    displayIntro()
    time.sleep(1)
    warmup()
    time.sleep(1)
    Guess()
    time.sleep(1)
    Multi()
    time.sleep(1)
    dragon()
    caveNumber = chooseCave()
    checkCave(caveNumber)
    print('Do you want to play again? (yes or no)')
    playAgain = input()




